diff --git a/lib/hive/web_app/provisioner.rb b/lib/hive/web_app/provisioner.rb
new file mode 100644
index 0000000..0017a23
--- /dev/null
+++ b/lib/hive/web_app/provisioner.rb
@@ -0,0 +1,268 @@
+require "fileutils"
+require "open3"
+require "tmpdir"
+require "hive"
+require "hive/paths"
+
+module Hive
+  module WebApp
+    # Discovers and provisions a runnable, version-matched copy of the Rails
+    # web app (the "web bundle") for local (non-Docker) installs.
+    #
+    # Discovery precedence:
+    #   1. HIVEBOX_WEB_APP_DIR   — operator override (Docker image, custom
+    #                              checkout); never touched or repaired.
+    #   2. gem-relative ../web   — source checkout (`git clone` root).
+    #   3. Managed dir           — $(XDG_DATA_HOME)/hive/web/app/<version>,
+    #                              materialized by #provision! from the
+    #                              release tarball (`hive-web-app-<v>.tar.gz`).
+    #
+    # The gem deliberately does NOT ship web/ (test/unit/gemspec_test.rb
+    # pins it), so on gem/brew/install.sh-only machines the managed copy is
+    # the only path. Everything network-touching goes through the injectable
+    # `downloader` seam so unit tests never hit the network; the real
+    # download is exercised by packaging/verify-release.sh and CI.
+    #
+    # provisioning recipe mirrors packaging/docker/Dockerfile's web layer:
+    #   bundle install && SECRET_KEY_BASE=… bin/rails assets:precompile
+    # with a deployment-style local bundle path and no dev/test gems.
+    class Provisioner
+      MANAGED_ROOT_SEGMENTS = %w[web app].freeze
+
+      # Raised when the web app cannot be located or provisioned. Carries
+      # operator-facing fix commands; `hive web` surfaces it verbatim.
+      class ProvisioningFailed < Hive::Error; end
+
+      def initialize(data_home: nil, version: Hive::VERSION,
+                     downloader: nil, runner: nil, release_host: nil,
+                     assume_yes: false, env: ENV, checkout_dir: nil)
+        @data_home = data_home || Hive::Paths.data_home
+        @version = version
+        @downloader = downloader
+        @runner = runner
+        @release_host = release_host
+        @assume_yes = assume_yes
+        @env = env
+        @checkout_dir = checkout_dir
+      end
+
+      # Locate a runnable web app without side effects. Returns the app dir
+      # when it holds a Rails app (config/application.rb), else nil.
+      def locate
+        candidates.find { |dir| File.file?(File.join(dir, "config", "application.rb")) }
+      end
+
+      # Locate-or-provision. When discovery finds nothing, downloads and
+      # builds the managed copy for the current Hive version.
+      def locate!
+        locate || provision!
+      end
+
+      def provision!
+        managed = managed_app_dir
+        if provisioned?(managed)
+          prune_old_versions
+          return managed
+        end
+
+        tarball = fetch_release_tarball
+        extract!(tarball, managed)
+        write_manifest(managed)
+        build_bundle!(managed)
+        precompile_assets!(managed)
+        prune_old_versions
+        managed
+      rescue StandardError => e
+        raise if e.is_a?(ProvisioningFailed)
+
+        raise ProvisioningFailed,
+              "hive: provisioning the web app failed: #{e.class}: #{e.message}. " \
+              "Retry with `hive setup`, or run from a source checkout where web/ exists."
+      end
+
+      # Manifest check: the managed copy must be pinned to the running gem's
+      # version — a stale app against a newer gem is an API-drift crash risk
+      # (plan risk 4). `repair!` re-provisions when versions diverge.
+      def repair!
+        managed = managed_app_dir
+        if locate && locate != managed
+          # checkout/env app: nothing to repair.
+          return locate
+        end
+        return managed if provisioned?(managed)
+
+        provision!
+      end
+
+      def managed_app_dir
+        File.join(@data_home, *MANAGED_ROOT_SEGMENTS, @version)
+      end
+
+      def managed_root
+        File.join(@data_home, *MANAGED_ROOT_SEGMENTS)
+      end
+
+      def self.release_asset_name(version)
+        "hive-web-app-#{version}.tar.gz"
+      end
+
+      private
+
+      def candidates
+        env_dir = @env["HIVEBOX_WEB_APP_DIR"]
+        [ env_dir, checkout_dir, managed_app_dir ].compact
+      end
+
+      # Gem-relative source checkout (repo root /web). Injectable so tests
+      # can simulate a gem-only machine even when run inside a checkout.
+      def checkout_dir
+        @checkout_dir ||= File.expand_path("../../../web", __dir__)
+      end
+
+      def provisioned?(dir)
+        File.file?(File.join(dir, "config", "application.rb")) &&
+          File.file?(manifest_path(dir)) &&
+          manifest_version(dir) == @version
+      end
+
+      def manifest_path(dir)
+        File.join(dir, "#{@version}.manifest")
+      end
+
+      def manifest_version(dir)
+        File.read(manifest_path(dir)).strip
+      rescue StandardError
+        nil
+      end
+
+      def write_manifest(dir)
+        File.write(manifest_path(dir), @version.to_s)
+      end
+
+      # ── fetch ────────────────────────────────────────────────────────
+
+      def fetch_release_tarball
+        url = release_url
+        dest = File.join(@data_home, "cache", "web-app", self.class.release_asset_name(@version))
+        FileUtils.mkdir_p(File.dirname(dest))
+        unless downloader.call(url, dest, expected_checksum(url))
+          raise ProvisioningFailed,
+                "hive: could not download the web app from #{url}. " \
+                "Verify the release exists (gh release view v#{@version}) or run from a source checkout."
+        end
+        dest
+      end
+
+      def release_url
+        "#{base_release_url}/v#{@version}/#{self.class.release_asset_name(@version)}"
+      end
+
+      def base_release_url
+        host = @release_host || "https://github.com"
+        "#{host}/#{Hive::REPO_OWNER}/#{Hive::REPO_NAME}/releases/download"
+      end
+
+      # Checksum lookup seam: returns nil when no checksum source is wired
+      # (tests, offline provision from cache). The production checksum feed
+      # is the release's SHA256SUMS asset — verify-release.sh cross-checks
+      # the published tarball, and the downloader seam can enforce it.
+      def expected_checksum(_url)
+        nil
+      end
+
+      def downloader
+        @downloader ||= lambda { |url, dest, _checksum|
+          # Real download path: curl is already a documented Hive
+          # prerequisite (install.sh uses it). --fail turns HTTP errors
+          # into a non-zero exit so the seam's boolean contract holds.
+          system(@env, "curl", "--fail", "--location", "--silent", "--show-error",
+                 "--output", dest, url)
+        }
+      end
+
+      # ── extract ──────────────────────────────────────────────────────
+
+      def extract!(tarball, managed)
+        FileUtils.mkdir_p(File.dirname(managed))
+        tmp = "#{managed}.extract-#{Process.pid}"
+        FileUtils.rm_rf(tmp)
+        FileUtils.mkdir_p(tmp)
+        ok = runner.call([ "tar", "-xzf", tarball, "-C", tmp ])
+        raise ProvisioningFailed, "hive: could not extract #{tarball}" unless ok
+
+        # The release tarball nests everything under a single top-level
+        # dir (web-app/); unwrap it so the managed dir IS the Rails app.
+        inner = Dir.children(tmp)
+        source = inner.size == 1 && File.directory?(File.join(tmp, inner.first)) ? File.join(tmp, inner.first) : tmp
+        FileUtils.rm_rf(managed)
+        FileUtils.mv(source, managed)
+      ensure
+        FileUtils.rm_rf(tmp) if File.directory?(tmp) && tmp != managed
+      end
+
+      def build_bundle!(app_dir)
+        ok = runner.call(
+          [ "bundle", "install", "--deployment", "--without", "development", "test",
+            "--path", File.join(app_dir, "vendor", "bundle") ],
+          chdir: app_dir
+        )
+        unless ok
+          raise ProvisioningFailed,
+                "hive: `bundle install` for the web app failed. Native gems " \
+                "(sqlite3, redcarpet) need build tools: on Debian/Ubuntu run " \
+                "`sudo apt install build-essential`; on macOS run " \
+                "`xcode-select --install`. Then retry `hive setup`."
+        end
+      end
+
+      def precompile_assets!(app_dir)
+        # Mirrors the Dockerfile web layer exactly: dummy secret (never
+        # reaches runtime) and a throwaway storage dir for the build.
+        env = {
+          "SECRET_KEY_BASE" => "assets-build-dummy",
+          "HIVEBOX_STORAGE_DIR" => File.join(Dir.tmpdir, "hive-web-assets-#{Process.pid}")
+        }
+        begin
+          ok = runner.call(
+            [ "bin/rails", "assets:precompile" ],
+            chdir: app_dir,
+            env: env
+          )
+        rescue StandardError => e
+          ok = false
+          @precompile_error = e
+        end
+        FileUtils.rm_rf(env["HIVEBOX_STORAGE_DIR"])
+        return if ok
+
+        raise ProvisioningFailed,
+              "hive: asset precompile failed in #{app_dir}" \
+              "#{@precompile_error ? " (#{@precompile_error.message})" : ''}; check the web bundle " \
+              "is complete (retry `hive setup`)."
+      end
+
+      # Keep at most KEEP_VERSIONS managed versions; older ones are pruned
+      # after a successful provision (plan risk 8: disk cost bound).
+      KEEP_VERSIONS = 2
+
+      def prune_old_versions
+        return unless File.directory?(managed_root)
+
+        versions = Dir.children(managed_root)
+                      .select { |v| File.directory?(File.join(managed_root, v)) }
+                      .sort
+        (versions[0...-KEEP_VERSIONS] || []).each do |old|
+          FileUtils.rm_rf(File.join(managed_root, old))
+        end
+      end
+
+      def runner
+        @runner ||= lambda { |argv, chdir: nil, env: nil|
+          out, err, status = Open3.capture3(env || {}, *argv, chdir: chdir)
+          [ out, err ].each { |io| warn io unless io.strip.empty? }
+          status.success?
+        }
+      end
+    end
+  end
+end
diff --git a/packaging/verify-release.sh b/packaging/verify-release.sh
index a66153e..6703d00 100755
--- a/packaging/verify-release.sh
+++ b/packaging/verify-release.sh
@@ -303,6 +303,55 @@ else
   fail "install-channel sidecar missing at $XDG_DATA_HOME/hive/install-channel"
 fi
 
+# ─── 1b. web app release asset ──────────────────────────────────────
+# The web tier ships as a SEPARATE release asset (the gem stays a lean
+# CLI). Verify the tarball is published for this release and that its
+# checksum matches the release's SHA256SUMS — the same contract
+# Hive::WebApp::Provisioner relies on when provisioning the managed web
+# bundle. Skipped gracefully when the pinned release predates the asset
+# (older releases legitimately have no hive-web-app-*.tar.gz).
+step "web app release asset (hive-web-app-*.tar.gz)"
+RELEASE_VERSION="${HIVE_VERSION#v}"
+WEB_APP_TARBALL="hive-web-app-${RELEASE_VERSION}.tar.gz"
+WEB_APP_URL="https://github.com/${HIVE_REPO_OWNER:-ivankuznetsov}/${HIVE_REPO_NAME:-hive}/releases/download/${HIVE_VERSION}/${WEB_APP_TARBALL}"
+set +e
+WEB_APP_HTTP_CODE="$(curl -sS -o "$PREFIX/$WEB_APP_TARBALL" -w '%{http_code}' --max-time 120 "$WEB_APP_URL")"
+WEB_APP_CURL_RC=$?
+set -e
+if [[ "$WEB_APP_HTTP_CODE" == "404" ]]; then
+  log "step: web app release asset — SKIPPED (release predates the web-app asset)"
+elif [[ $WEB_APP_CURL_RC -ne 0 || "$WEB_APP_HTTP_CODE" != "200" ]]; then
+  fail "could not download web app asset (http=$WEB_APP_HTTP_CODE, curl rc=$WEB_APP_CURL_RC)"
+else
+  ok "web app asset downloadable at ${WEB_APP_URL}"
+  SHA256SUMS_URL="https://github.com/${HIVE_REPO_OWNER:-ivankuznetsov}/${HIVE_REPO_NAME:-hive}/releases/download/${HIVE_VERSION}/SHA256SUMS"
+  set +e
+  SUMS_HTTP_CODE="$(curl -sS -o "$PREFIX/SHA256SUMS" -w '%{http_code}' --max-time 60 "$SHA256SUMS_URL")"
+  set -e
+  if [[ "$SUMS_HTTP_CODE" == "200" ]] && grep -q "$WEB_APP_TARBALL" "$PREFIX/SHA256SUMS" 2>/dev/null; then
+    expected="$(awk -v f="$WEB_APP_TARBALL" '$2 ~ f { print $1 }' "$PREFIX/SHA256SUMS")"
+    actual="$(sha256sum "$PREFIX/$WEB_APP_TARBALL" | awk '{print $1}')"
+    if [[ -n "$expected" && "$expected" == "$actual" ]]; then
+      ok "web app asset checksum matches SHA256SUMS"
+    else
+      fail "web app asset checksum MISMATCH (expected ${expected:-none}, got ${actual:-none})"
+    fi
+  else
+    fail "SHA256SUMS unavailable or missing a web-app entry (http=$SUMS_HTTP_CODE) — the release job must checksum every published asset"
+  fi
+  # Tarball shape: single web-app/ root with the Rails skeleton.
+  if tar -tzf "$PREFIX/$WEB_APP_TARBALL" >/dev/null 2>&1; then
+    if tar -tzf "$PREFIX/$WEB_APP_TARBALL" | grep -q '^web-app/Gemfile$' \
+       && tar -tzf "$PREFIX/$WEB_APP_TARBALL" | grep -q '^web-app/config/application.rb$'; then
+      ok "web app tarball contains the Rails skeleton under web-app/"
+    else
+      fail "web app tarball is missing expected entries (web-app/Gemfile, web-app/config/application.rb)"
+    fi
+  else
+    fail "web app tarball is not a valid gzip tarball"
+  fi
+fi
+
 # ─── 2. doctor ───────────────────────────────────────────────────────
 
 step "hive doctor"
diff --git a/test/unit/cli_test.rb b/test/unit/cli_test.rb
index dafa1c2..a611fad 100644
--- a/test/unit/cli_test.rb
+++ b/test/unit/cli_test.rb
@@ -519,23 +519,100 @@ class HiveCliTest < Minitest::Test
     require "hive/commands/web"
     captured = []
     recorder = Class.new do
-      define_method(:initialize) { |bind:, port:| captured << { bind: bind, port: port } }
+      define_method(:initialize) { |**kwargs| captured << kwargs }
       define_method(:call) { captured << :called }
     end
 
+    with_swapped_web_command(recorder) do
+      capture_io { Hive::CLI.start([ "web", "--bind", "0.0.0.0", "--port", "9123" ]) }
+    end
+
+    assert_equal({ bind: "0.0.0.0", port: 9123, allow_public_noauth: false, assume_yes: false },
+                 captured.first,
+                 "the --bind/--port flags must reach the web command")
+    assert_equal :called, captured.last, "hive web must invoke the web command's #call"
+  end
+
+  def test_web_forwards_allow_public_noauth_and_yes_flags
+    require "hive/commands/web"
+    captured = []
+    recorder = Class.new do
+      define_method(:initialize) { |**kwargs| captured << kwargs }
+      define_method(:call) { captured << :called }
+    end
+
+    with_swapped_web_command(recorder) do
+      capture_io { Hive::CLI.start([ "web", "--allow-public-noauth", "--yes" ]) }
+    end
+
+    assert captured.first.fetch(:allow_public_noauth), "--allow-public-noauth must reach the command"
+    assert captured.first.fetch(:assume_yes), "--yes must reach the command"
+  end
+
+  # U4: `hive web install|start|stop|status` dispatches to the service
+  # command, NOT the foreground server. Routing is pinned here so a Thor
+  # refactor can never silently merge the two surfaces (plan risk 9).
+  def test_web_subcommands_dispatch_to_web_service
+    require "hive/commands/web_service"
+    captured = []
+    recorder = Class.new do
+      define_method(:initialize) { |sub, json: false, force: false, autostart: true| captured << [ sub, json, force, autostart ] }
+      define_method(:call) { captured << :called }
+    end
+
+    original = Hive::Commands.const_get(:WebService)
+    Hive::Commands.send(:remove_const, :WebService)
+    Hive::Commands.const_set(:WebService, recorder)
+    begin
+      capture_io { Hive::CLI.start([ "web", "install", "--force", "--json" ]) }
+    ensure
+      Hive::Commands.send(:remove_const, :WebService)
+      Hive::Commands.const_set(:WebService, original)
+    end
+
+    assert_equal [ "install", true, true, true ], captured.first
+    assert_equal :called, captured.last
+  end
+
+  def test_setup_dispatches_to_setup_command
+    require "hive/commands/setup"
+    captured = []
+    recorder = Class.new do
+      define_method(:initialize) { |**kwargs| captured << kwargs }
+      define_method(:call) { 0 } # exit code 0
+    end
+
+    original = Hive::Commands.const_get(:Setup)
+    Hive::Commands.send(:remove_const, :Setup)
+    Hive::Commands.const_set(:Setup, recorder)
+    begin
+      # The CLI maps the command's return value onto `exit N`; catch the
+      # SystemExit so Minitest keeps running.
+      capture_io do
+        err = assert_raises(SystemExit) { Hive::CLI.start([ "setup", "--skip-web", "--skip-daemon", "--no-enroll", "--json" ]) }
+        assert_equal 0, err.status
+      end
+    ensure
+      Hive::Commands.send(:remove_const, :Setup)
+      Hive::Commands.const_set(:Setup, original)
+    end
+
+    assert captured.first.fetch(:skip_web)
+    assert captured.first.fetch(:skip_daemon)
+    refute captured.first.fetch(:enroll)
+    assert captured.first.fetch(:json)
+  end
+
+  def with_swapped_web_command(recorder)
     original = Hive::Commands.const_get(:Web)
     Hive::Commands.send(:remove_const, :Web)
     Hive::Commands.const_set(:Web, recorder)
     begin
-      capture_io { Hive::CLI.start([ "web", "--bind", "0.0.0.0", "--port", "9123" ]) }
+      yield
     ensure
       Hive::Commands.send(:remove_const, :Web)
       Hive::Commands.const_set(:Web, original)
     end
-
-    assert_equal({ bind: "0.0.0.0", port: 9123 }, captured.first,
-                 "the --bind/--port flags must reach the web command")
-    assert_equal :called, captured.last, "hive web must invoke the web command's #call"
   end
 
   def test_daemon_argv_errors_emit_json_envelopes_before_raising
diff --git a/test/unit/commands/daemon_test.rb b/test/unit/commands/daemon_test.rb
index f87b788..22ccc03 100644
--- a/test/unit/commands/daemon_test.rb
+++ b/test/unit/commands/daemon_test.rb
@@ -297,6 +297,28 @@ class HiveCommandsDaemonTest < Minitest::Test
     assert_operator doc.fetch("uptime_sec"), :>=, 0
   end
 
+  # U5: the v2 additive `consistency` block. On a sandbox with no installed
+  # unit and no live daemon, running=false and the probe reports drift none.
+  # `status --json` still exits 1 when the daemon is down — the envelope is
+  # printed before the raise.
+  def test_status_json_includes_consistency_probe
+    command = daemon("status", json: true)
+
+    out, _err = capture_io do
+      assert_raises(Hive::Error) { command.call }
+    end
+
+    doc = JSON.parse(out)
+    consistency = doc.fetch("consistency")
+    assert_equal false, consistency.fetch("running")
+    assert_equal "none", consistency.fetch("drift_kind")
+
+    require "json_schemer"
+    schema = JSONSchemer.schema(JSON.parse(File.read(Hive::Schemas.schema_path("hive-daemon-status"))))
+    assert_empty schema.validate(doc).map { |error| error["error"] },
+                 "the v2 envelope must validate against hive-daemon-status.v2"
+  end
+
 
   def test_status_json_includes_update_nudge_when_present
     with_env("HIVE_HOME" => @home) do
diff --git a/test/unit/commands/doctor_test.rb b/test/unit/commands/doctor_test.rb
index 946169f..577d618 100644
--- a/test/unit/commands/doctor_test.rb
+++ b/test/unit/commands/doctor_test.rb
@@ -46,6 +46,69 @@ class HiveCommandsDoctorTest < Minitest::Test
     end
   end
 
+  # U5: a unit file baking a drifted binary (e.g. /usr/bin/hive while the
+  # CLI resolves elsewhere) must surface as a `warning` row with the exact
+  # repair command — without flipping doctor's exit code.
+  def test_daemon_binary_drift_renders_warning_row_with_fix_hint
+    with_fake_home do |home|
+      write_file(
+        File.join(home, ".config/systemd/user/hive-daemon.service"),
+        <<~UNIT
+          [Service]
+          Environment=HIVE_BIN=/usr/bin/hive
+          ExecStart=/usr/bin/hive daemon start
+        UNIT
+      )
+      cli_bin = File.join(home, "bin", "hive")
+      write_file(cli_bin, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, cli_bin)
+
+      old = ENV["HIVE_INVOKED_BIN"]
+      ENV["HIVE_INVOKED_BIN"] = cli_bin
+      out = StringIO.new
+      begin
+        exit_code = Hive::Commands::Doctor.new(
+          config: base_config, project_root: nil, json: false, output: out
+        ).call
+      ensure
+        old.nil? ? ENV.delete("HIVE_INVOKED_BIN") : ENV["HIVE_INVOKED_BIN"] = old
+      end
+
+      assert_equal Hive::Commands::Doctor::EXIT_MISSING_SKILL, exit_code,
+                   "stage checks still drive the exit code; drift is only a warning"
+      assert_match(%r{daemon/binary.*warning}m, out.string)
+      assert_match(/hive daemon install --force/, out.string)
+    end
+  end
+
+  def test_daemon_binary_consistent_renders_present_row
+    with_fake_home do |home|
+      cli_bin = File.join(home, "bin", "hive")
+      write_file(cli_bin, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, cli_bin)
+      write_file(
+        File.join(home, ".config/systemd/user/hive-daemon.service"),
+        "[Service]\nExecStart=#{cli_bin} daemon start\n"
+      )
+
+      old = ENV["HIVE_INVOKED_BIN"]
+      ENV["HIVE_INVOKED_BIN"] = cli_bin
+      out = StringIO.new
+      begin
+        Hive::Commands::Doctor.new(
+          config: base_config, project_root: nil, json: true, output: out
+        ).call
+      ensure
+        old.nil? ? ENV.delete("HIVE_INVOKED_BIN") : ENV["HIVE_INVOKED_BIN"] = old
+      end
+
+      env = JSON.parse(out.string)
+      row = env["checks"].find { |c| c["label"] == "daemon/binary" }
+      refute_nil row, "the daemon/binary row must always render"
+      assert_equal "present", row["status"]
+    end
+  end
+
   def test_exit_success_when_all_present
     with_fake_home do |home|
       write_file("#{home}/.claude/plugins/cache/mp/compound-engineering/3.0.1/skills/ce-brainstorm/SKILL.md")
@@ -187,9 +250,9 @@ class HiveCommandsDoctorTest < Minitest::Test
 
       env = JSON.parse(out.string)
       assert_equal "hive-doctor.v1", env["schema"]
-      assert_equal 2, env["checks"].length
+      assert_equal 3, env["checks"].length
       assert_equal 1, env["summary"]["missing"]
-      assert_equal 1, env["summary"]["present"]
+      assert_equal 2, env["summary"]["present"]
       assert(env["checks"].any? { |c| c["stage"] == "plan" && c["status"] == "present" })
       assert(env["checks"].any? { |c| c["stage"] == "brainstorm" && c["status"] == "missing" })
     end
@@ -734,7 +797,7 @@ class HiveCommandsDoctorTest < Minitest::Test
 
       env = JSON.parse(out.string)
       assert_equal "hive-doctor.v1", env["schema"]
-      assert_equal 3, env["checks"].length
+      assert_equal 4, env["checks"].length
 
       stage_entries = env["checks"].select { |c| c["kind"] == "stage" }
       reviewer_entries = env["checks"].select { |c| c["kind"] == "reviewer" }
diff --git a/test/unit/commands/setup/dependency_checks_test.rb b/test/unit/commands/setup/dependency_checks_test.rb
new file mode 100644
index 0000000..8fb9741
--- /dev/null
+++ b/test/unit/commands/setup/dependency_checks_test.rb
@@ -0,0 +1,135 @@
+require "test_helper"
+require "hive/commands/setup/dependency_checks"
+
+class SetupDependencyChecksTest < Minitest::Test
+  include HiveTestHelper
+
+  def build(path_tools:, npm:, runner: nil, qmd: nil)
+    fake_bin = File.join(@dir, "bin")
+    FileUtils.mkdir_p(fake_bin)
+    Array(path_tools).each do |tool|
+      path = File.join(fake_bin, tool)
+      File.write(path, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, path)
+    end
+    if npm
+      path = File.join(fake_bin, "npm")
+      File.write(path, "#!/bin/sh\nexit 0\n")
+      FileUtils.chmod(0o755, path)
+    end
+
+    Hive::Commands::Setup::DependencyChecks.new(
+      env: {
+        # ONLY the fake bin dir: the real host PATH would leak actual git/
+        # npm installs into what must be a hermetic matrix.
+        "PATH" => fake_bin,
+        "HOME" => @dir,
+        "XDG_DATA_HOME" => File.join(@dir, "data")
+      },
+      runner: runner || ->(_argv, chdir: nil, env: nil) { true },
+      qmd_finder: qmd ? -> { File.join(@dir, "bin", "qmd") } : -> { nil }
+    )
+  end
+
+  def with_sandbox
+    Dir.mktmpdir("hive-setup-deps") do |dir|
+      @dir = dir
+      yield dir
+    end
+  end
+
+  def row(setup, name)
+    setup.rows.find { |r| r["name"] == name }
+  end
+
+  def test_external_tools_on_path_are_present
+    with_sandbox do
+      setup = build(path_tools: %w[git tmux gh claude codex node npm], npm: true)
+      setup.call
+
+      %w[git tmux gh claude codex node npm].each do |tool|
+        assert_equal "present", row(setup, tool)["status"], "#{tool} on PATH must be present"
+        assert_equal "external", row(setup, tool)["kind"]
+      end
+    end
+  end
+
+  def test_missing_external_tool_is_reported_with_exact_fix_command
+    with_sandbox do
+      setup = build(path_tools: [], npm: false)
+      setup.call
+
+      git_row = row(setup, "git")
+      assert_equal "missing", git_row["status"]
+      assert_match(/sudo apt install git/, git_row["message"])
+      assert_match(/brew install git/, git_row["message"])
+
+      tmux_row = row(setup, "tmux")
+      assert_equal "missing", tmux_row["status"]
+      assert_match(/fix:/, tmux_row["message"])
+    end
+  end
+
+  def test_missing_qmd_with_npm_available_is_repaired
+    with_sandbox do |dir|
+      ran = []
+      setup = build(
+        path_tools: %w[node npm], npm: true,
+        runner: lambda { |argv, chdir: nil, env: nil|
+          ran << argv
+          true
+        },
+        qmd: nil
+      )
+      # After the repair runs, the qmd_finder is re-consulted; make it
+      # succeed post-install.
+      finder = -> { ran.empty? ? nil : File.join(@dir, "data", "hive", "qmd", "bin", "qmd") }
+      setup.instance_variable_set(:@qmd_finder, finder)
+      setup.call
+
+      assert_equal ["npm", "install", "--global", "--prefix", File.join(@dir, "data", "hive", "qmd"), "@tobilu/qmd"],
+                   ran.first,
+                   "qmd repair must run the exact npm command the update flow/doctor emit"
+      assert_equal "repaired", row(setup, "qmd")["status"]
+    end
+  end
+
+  def test_missing_qmd_without_npm_fails_with_guidance_never_installs_npm
+    with_sandbox do
+      ran = []
+      setup = build(
+        path_tools: %w[node], npm: false,
+        runner: ->(argv, chdir: nil, env: nil) { ran << argv; true }
+      )
+      setup.call
+
+      qmd_row = row(setup, "qmd")
+      assert_equal "failed", qmd_row["status"]
+      assert_match(/npm install --global --prefix/, qmd_row["message"])
+      assert_empty ran, "the runner must never be invoked when npm is missing"
+    end
+  end
+
+  def test_qmd_repair_failure_is_reported
+    with_sandbox do
+      setup = build(
+        path_tools: %w[node npm], npm: true,
+        runner: ->(_argv, chdir: nil, env: nil) { false }
+      )
+      setup.call
+
+      assert_equal "failed", row(setup, "qmd")["status"]
+      assert_match(/qmd repair failed/, row(setup, "qmd")["message"])
+    end
+  end
+
+  def test_ruby_version_check_passes_on_modern_ruby
+    with_sandbox do
+      setup = build(path_tools: [], npm: false)
+      setup.call
+
+      assert_equal "present", row(setup, "ruby")["status"]
+      assert_match(/Ruby #{RUBY_VERSION}/, row(setup, "ruby")["message"])
+    end
+  end
+end
